local addonInfo, privateVars = ...

if nkPanelSoulVitality ~= nil then return end
nkPanelSoulVitality = {}

function nkPanelSoulVitality.main(_, addon)

	if addon == addonInfo.identifier then
	
		nkPanel.api.registerPlugin('Soul vitality plugin', nkPanelSoulVitality.plugin())
	end
	
end

Command.Event.Attach(Event.Addon.Load.End, nkPanelSoulVitality.main, "nkPanelSoulVitality.Addon.Load.End")

--------------------------------------------------------------------------------------------------------------------------------------------

function nkPanelSoulVitality.plugin()
		
	local plugin = nkPanel.api.plugin('vitality plugin', true, false)
	local playerUNID

	plugin:SetTitle(string.format(nkPanelSoulVitality.langTexts.title, 0))
	
	plugin:SetThumb('nkPanel_SoulVitality', 'gfx/nkPanelIcon.png')
	
	local function playerReady (_, units)
	
		if playerUNID == nil then
			local details = Inspect.Unit.Detail('player')
			if details ~= nil then playerUNID = details.id end
			if playerUNID == nil then return end
		end
		
		if units[playerUNID] == nil then return end

		local details = Inspect.Unit.Detail(playerUNID)
		if details ~= nil then		
			plugin:SetTitle(string.format(nkPanelSoulVitality.langTexts.title, details.vitality))
		end
		
		local function vitalityChange(_, units)
			if units[playerUNID] == nil then return end
			
			plugin:SetTitle(string.format(nkPanelSoulVitality.langTexts.title, units[playerUNID]))
		end
		
		Command.Event.Attach(Event.Unit.Detail.Vitality, vitalityChange, "nkPanelSoulVitality.Unit.Detail.Vitality")

		Command.Event.Detach(Event.Unit.Availability.Full, nil, "nkPanelSoulVitality.Unit.Availability.Full")
	end
	
	Command.Event.Attach(Event.Unit.Availability.Full, playerReady, "nkPanelSoulVitality.Unit.Availability.Full")
	
	return plugin

end